#ifndef _MAIN_H
#define _MAIN_H

#include <time.h>
#include <stdlib.h>
#include <allegro.h>

/////////////// FUNCTION RETURN VALUES /////////////////////////
#define SUCCESS 1
#define FAILURE -1
//#define TRUE 1
//#define FALSE 0
/////////////// GRAPHICS SETTINGS //////////////////////////////
#define SCREEN_WIDTH 640
#define SCREEN_HEIGHT 480
#define BPP 8
#define NCOLORS 256
///////////////////// GRAPHICS DEFINES //////////////////////////
#define LARVA_FRAMES 2
#define ALIEN_FRAMES 2
#define SHIP_FRAMES 4
#define HATCH_FRAMES 9
#define SHOT_FRAMES 2
#define LARVA_CHANGE_RATE 20
#define ALIEN_CHANGE_RATE 10
#define UNIT_BLOCK_WIDTH 16
#define UNIT_BLOCK_HEIGHT 16
///////////////////// GAME DEFINES //////////////////////////////
#define HATCH_RATE 150
#define LARVA_MOVE_RATE 20
#define ALIEN_MOVE_RATE 10
#define BOARD_X_SIZE 30
#define BOARD_Y_SIZE 22
#define ALIEN_HITS 4
#define SMALL_SIZE 16
#define LARGE_SIZE 32
#define FREE 0
#define SHIP 1
#define WALL 2
#define BOX 3
#define LARVA 4
#define ALIEN 5
#define DOWN 0
#define LEFT 1
#define UP 2
#define RIGHT 3
///////////////////// GRAPHICS GLOBALS //////////////////////////
extern BITMAP *double_buffer;
extern BITMAP *characters;
extern BITMAP *allS;
///////////////////// FUNCTION PROTOTYPES ///////////////////////
int load_sprites();
int init();
void free_all();
void mike_wait(int length);
///////////////////// GLOBALS ///////////////////////////
extern int high_score, high_level;

#endif
